( System-Vocabulary fr S-Forth, Version 2.0 )

( **  Achtung ! Vorlufige Testversion, noch nicht dokumentiert )
( **  und ausgetestet. Vorschlge und Ergnzungen bitte an die  )
( **  Redaktion DOS International, zu Hnden Volker Everts      )


include forth


vocabulary system


( ----- Direkte Registerzugriffe ---------------- )


macro bx! [ $89 $C3 ] ( mov bx,ax ) drop ;
macro cx! [ $89 $C1 ] ( mov cx,ax ) drop ;
macro dx! [ $89 $C2 ] ( mov dx,ax ) drop ;
macro di! [ $89 $C7 ] ( mov di,ax ) drop ;
macro es! [ $8E $C0 ] ( mov es,ax ) drop ;

: bx@ dup [ $89 $D8 ] ( mov ax,bx ) ;
: cx@ dup [ $89 $C8 ] ( mov ax,cx ) ;
: dx@ dup [ $89 $D0 ] ( mov ax,dx ) ;
: di@ dup [ $89 $F8 ] ( mov ax,di ) ;
: es@ dup [ $8C $C0 ] ( mov ax,es ) ;

macro cx> [ $51 ] ( push cx ) ;
macro si> [ $56 ] ( push si ) ;
macro di> [ $57 ] ( push di ) ;
macro ds> [ $1E ] ( push ds ) ;

macro >cx [ $59 ] ( pop cx ) ;
macro >si [ $5E ] ( pop si ) ;
macro >di [ $5F ] ( pop di ) ;
macro >ds [ $1F ] ( pop ds ) ;


( ----- Segmentierter Speicherzugriff ----------- )


: !% ( n ofs seg --> ) ( Wort an Adresse seg:ofs ablegen )
  es! bx!
  [ $26 $89 $07 ] ( mov [es:bx],ax )
  drop
;


: c!% ( c ofs seg --> ) ( Zeichen an Adresse seg:ofs ablegen )
  es! bx!
  [ $26 $88 $07 ] ( mov [es:bx],al )
  drop
;


: @% ( ofs seg --> n ) ( Wort aus Adresse seg:ofs holen )
  es!
  [ $89 $C3 ]     ( mov bx,ax      )
  [ $26 $8B $07 ] ( mov ax,[es:bx] )
;


: c@% ( ofs seg --> c ) ( Zeichen aus Adresse seg:ofs holen )
  es!
  [ $89 $C3 ]     ( mov bx,ax      )
  [ $26 $8A $07 ] ( mov al,[es:bx] )
  [ $B4 $00 ]     ( mov ah,0 )
;


: cmove% ( ofs.von seg.von ofs.bis seg.bis n --> )
  cx> cx!     ( Lnge nach cx )
  es!         ( Zielsegment nach es )
  di> di!     ( Zieloffset nach di )
  bx!         ( Quellsegment zwischenspeichern )
  si> ds>     ( Register retten )
  [ $89 $C6 ] ( mov si,ax )
  [ $8E $DB ] ( mov ds,bx )
  [ $F3 $A4 ] ( rep movsb )
  >ds >si     ( Register zurckholen )
  >di >cx
  drop
;


: fill% ( ofs seg n c --> )
  dx!         ( Zeichen zwischenspeichern )
  cx> cx!     ( Lnge setzen )
  es!         ( Segment setzen )
  di> di!     ( Offset setzen )
  dx@         ( Zeichen holen )
  [ $F3 $AA ] ( rep stosb )
  >di >cx     ( Register zurck )
  drop
;


: fillw% ( ofs seg n w --> )
  dx!         ( Wort zwischenspeichern )
  cx> cx!     ( Lnge setzen )
  es!         ( Segment setzen )
  di> di!     ( Offset setzen )
  dx@         ( Wort holen )
  [ $F3 $AB ] ( rep stosw )
  >di >cx     ( Register zurck )
  drop
;


( ----- verschiedene  Funktionen ---------------- )


macro call ( adr --> n )
  [ $FF $D0 ] ( call ax )
;


: port! ( n adr --> )
  dx! [ $EF ] ( out dx,ax )
  drop
;


: port@ ( adr --> n )
  dx! dup [ $ED ] ( in ax,dx )
;


: shr ( n1 n --> n2 )
  cx> cx!
  [ $D1 $E8 ] ( shr ax,cl )
  >cx
;


: shl ( n1 n --> n2 )
  cx> cx!
  [ $D3 $E0 ] ( shl ax,cl )
  >cx
;



( ----- Interrupt-Handhabung -------------------- )


variable doserr 0   ( MS-DOS-Fehlernummer )


macro intr [ $cd ] ( Interrupt-Byte ) ;


: ?carry ( --> flag ) ( CPU-Carry-Flag testen )
  false
  [ $73 1 ] ( jnc +1 )
  1-
;


: ?err ( n --> )
  ?carry not
  if drop 0 endif
  doserr !
;


: ??err ( n -- code )
  dup ?err
  doserr @
  if drop 0 endif
;


macro -dos ( --> ) ( MS-DOS-Funktion aufrufen )
  intr [ $21 ]  ( int 21h )
;


macro -video ( --> ) ( Video-Interrupt aufrufen )
  intr [ $10 ]  ( int 10h )
;


: >int ( n adr --> )  ( Interrupt-Vektor setzen )
  dx! $FF and $2500 or -dos drop
;


: int> ( n --> d )  ( Interrupt-Vektor holen )
  $FF and $3500 or -dos
  drop bx@ es@
;


macro ;intr  ( Return from Interrupt )
  [ $CF ] ( iret )
;


macro (cli)
  [ $FA ] ( cli )
;


( ----- Datei-System ---------------------------- )


constant a: 0  ( Laufwerk A: )
constant b: 1  ( Laufwerk B: )
constant c: 2  ( Laufwerk C: )
constant d: 3  ( Laufwerk D: )
constant dta $80 ( Disk Transfer Area )


: halt ( n --> )  ( Programm mit Return-Code beenden )
  $FF and $4C00 or -dos
;


: reset ( --> )  ( Diskettensystem zurcksetzen )
  $0D00 -dos
;


: drive ( n --> )  ( Default-Laufwerk whlen )
  dx! $0E00 -dos
;


: ?drive ( --> n )  ( Default-Laufwerk holen )
  $1900 -dos
  [ $B4 $00 ]     ( mov ah,0 )
;


: asciiz$ ( str1 --> str2 )  ( MS-DOS-Stringformat herstellen )
  count over +  ( Stringende )
  0 swap !      ( Nullbyte eintragen )
;


: mkdir ( str --> )  ( Unterverzeichnis anlegen )
  asciiz$ dx! ( Pfadname )
  $3900 -dos  ( Funktionsaufruf )
  ?err
;


: rmdir ( str --> )  ( Unterverzeichnis lschen )
  asciiz$ dx! ( Pfadname )
  $3A00 -dos  ( Funktionsaufruf )
  ?err
;


: chdir ( str --> )  ( Unterverzeichnis wechseln )
  asciiz$ dx! ( Pfadname )
  $3B00 -dos  ( Funktionsaufruf )
  ?err
;


: create ( str --> n )  ( neue Datei anlegen )
  cx> 0 cx!   ( Attribut R/W )
  asciiz$ dx! ( Pfadname )
  $3C00 -dos  ( Funktionsaufruf )
  ??err
;


: open ( str --> n )  ( Datei ffnen )
  asciiz$ dx! ( Pfadname )
  $3D02 -dos  ( Funktionsaufruf )
  ??err
;


: read ( adr count handle --> n )
  bx! cx> cx! dx!
  $3F00 -dos >cx
  ??err
;


: write ( adr count handle --> n )
  bx! cx> cx! dx!
  $4000 -dos >cx
  ??err
;


: delete ( str --> )
  asciiz$ dx!
  $4100 -dos
  ?err
;


: seek ( n handle --> )
  bx! cx> cx!
  $4200 -dos
  >cx ?err
;


: seek+ ( n handle --> )
  bx! cx> cx!
  $4201 -dos
  >cx ?err
;


: seekeof ( handle --> )
  bx! cx> 0 cx!
  $4202 -dos
  >cx ?err
;


: >attr ( str attr --> )
  cx> cx!
  asciiz$ dx!
  $4301 -dos
  >cx ?err
;


: attr> ( str --> attr )
  cx> asciiz$ dx!
  $4300 -dos
  ?err cx@ >cx
;


: firstfile ( str attr --> )
  cx> cx!
  asciiz$ dx!
  $4E00 -dos
  >cx ?err
;


: nextfile ( --> )
  $4F00 -dos
  ?err
;


: fattr ( --> n )  ( Dateiattribut )
  dta 21 + c@
;


: ftime ( --> n )  ( Dateizeit)
  dta 22 + @
;


: fdate ( --> n )  ( Dateidatum )
  dta 24 + @
;


: flen ( --> d )  ( Dateilnge )
  dta 26 + d@
;


: fname ( --> str )  ( Dateiname )
  dta 29 +       ( Adresse Name )
  0 pad c!
  13 1
  do
    dup i + c@   ( Zeichen holen )
    dup
    if
      pad ++     ( Count erhhen )
      pad i + c! ( Zeichen speichern )
    else
      drop
      leave
    endif
  loop
  drop pad
;


( ----- Video-Steuerung ------------------------- )


variable scrpage 0  ( Bildschirmseite )


: (page)  ( Bildschirmseite nach bh )
  scrpage @ 8 shl bx!
;


: (build)  ( zwei 8-Bit-Werte --> 16 Bit )
  8 shl or
;


: scrmode ( n --> )  ( Bildschirmmodus setzen )
  $FF and -video drop
;


: cursize ( n1 n2 --> )  ( Cursorgre setzen )
  cx> (build) cx!
  $0100 -video
  >cx drop
;


: locate ( y x --> )  ( Cursorposition setzen )
  (page)
  (build) dx!
  $0200 -video
  drop
;


: ?cursor ( --> y x )  ( Cursorposition holen )
  (page)
  $0300 -video
  drop dx@
  dup $FF and
  swap 8 shr
;


: tab ( n --> )  ( Tabulatorposition setzen )
  ?cursor drop swap locate
;


: page ( n --> )  ( Bildschirmseite setzen )
  (page) $0500 -video drop
;


(save.voc)


: main
;