( Vokabular ISYS fr Interrupt-   )
( handling und TSR Programmierung )
( nur mit modifiziertem Compiler  )
( ab Version 3.0 verwenden !      )
( [c] Erwin Schomburg             )


include forth  ( Achtung, nur Forth-Vocabulary ab Version 1.4 verwenden ! )

vocabulary isys

variable ax 0        ( Diese Variablen korrespondieren  )
variable bx 0        ( mit den gleichnamigen Prozessor- )
variable cx 0        ( Registern !                      )
variable dx 0

: makevect ( var --- )              ( 4 Byte im Heap reservieren   )
              here swap ! 4 allot   ( Variable zeigt auf diesen    )
              ;                     ( Bereich                      )

: vectlo ( var --- loaddr )         ( Adresse von LO Wort des      )
              @                     ( Vektors auf den die          )
              ;                     ( Variable zeigt auf TOS legen )

: vecthi ( var --- hiaddr )         ( dto. Adresse HI Wort         )
              @ 2+
              ;

: getvect ( intnum var --- )        ( Interruptvektor holen und sichern )
              [ $53 ]      ( push bx )
              [ $06 ]      ( push es )
              swap
              $00ff and
              $3500 or
              [ $cd $21 ]  ( int 21  )
              [ $53 ]      ( push bx )
              [ $06 ]      ( push es )
              [ $58 ]      ( pop ax  )
              over
              vecthi !
              dup
              [ $58 ]      ( pop ax  )
              swap
              vectlo !
              [ $07 ]      ( pop es  )
              [ $5b ]      ( pop bx  )
              ;


: setvect ( intnum var --- )  ( Interruptvektor setzen )
              [ $52 ]      ( push dx )
              [ $1e ]      ( push ds )
              dup vecthi @
              >r
              vectlo @
              >r
              $00ff and
              $2500 or
              [ $5a ]      ( pop dx  )
              [ $1f ]      ( pop ds  )
              [ $cd $21 ]  ( int 21  )
              [ $1f ]      ( pop ds  )
              [ $5a ]      ( pop dx  )
              drop
              ;

macro ds@     ( DS Registerinhalt auf TOS )
              dup
              [ $8c $d8 ]  ( mov ax,ds )
              ;

macro cs@     ( CS Registerinhalt auf TOS )
              dup
              [ $8c $c8 ]  ( mov ax,cs )
              ;

( beginint < --- >           Definition im Compiler )
( endint   < --- >           Definition im Compiler )
( exitto   < vectvar  --- >  Definition im Compiler )
( callto   < vectvar  --- >  Definition im Compiler )
( find     < --- addr>       Definition im Compiler )
( int      < intno --- >     Definition im Compiler )

: keep ( --- )
              s0 @
              16 /
              1+
              >r
              $3100
              [ $5a ]     ( pop dx )
              [ $cd $21 ] ( int 21 )
              ;

(save.voc)

: main ;